-------------
--Main Menu--
-------------
local mainRes = [["main"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"220"
		"tall"		"90"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Main Menu"
		"sizable"		"0"
	}
	"admin"
	{
		"ControlName"		"Button"
		"fieldName"		"admin"
		"xpos"		"20"
		"ypos"		"40"
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Admin Menu"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"admin"
		"Default"		"0"
	}
	"client"
	{
		"ControlName"		"Button"
		"fieldName"		"client"
		"xpos"		"120"
		"ypos"		"40"
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Client Menu"
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"client"
		"Default"		"0"
	}
}]]

local mainMenu

function ulx.showMainMenu()
	if mainMenu then mainMenu:SetVisible( true ) return end

	mainMenu = vgui.Create( "Frame" )
	mainMenu:SetName( "window" )

	local admin = vgui.Create( "Button", mainMenu, "admin" )
	admin:SetActionFunction( mainMenuCallback )

	local client = vgui.Create( "Button", mainMenu, "client" )
	client:SetActionFunction( mainMenuCallback )

	mainMenu:LoadControlsFromString( mainRes )
	mainMenu:SetKeyBoardInputEnabled( true )
	mainMenu:SetMouseInputEnabled( true )

	mainMenu:SetPos( ScrW()*0.45, ScrH()-100 )
	mainMenu:SetVisible( true )
end

function mainMenuCallback( panel, type, value )
	if value == "admin" then
		mainMenu:SetVisible( false )
		ulx.showAdminMenu()
	elseif value == "client" then
		mainMenu:SetVisible( false )
		ulx.showClientMenu()		
	end
end


--------------
--Admin Menu--
--------------
local adminRes = [["admin"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"700"
		"tall"		"440"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Admin Menu"
		"sizable"		"0"
	}
	"npcs"
	{
		"ControlName"		"CheckButton"
		"fieldName"		"npcs"
		"xpos"		"20"
		"ypos"		"50"
		"wide"		"150"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Allow NPCs"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
		"Default"		"0"
	}
	"god"
	{
		"ControlName"		"CheckButton"
		"fieldName"		"god"
		"xpos"		"20"
		"ypos"		"80"
		"wide"		"150"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Global Godmode"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
		"Default"		"0"
	}
	"pvp"
	{
		"ControlName"		"CheckButton"
		"fieldName"		"pvp"
		"xpos"		"20"
		"ypos"		"110"
		"wide"		"150"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"No PvP Damage"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
		"Default"		"0"
	}
	"noclip"
	{
		"ControlName"		"CheckButton"
		"fieldName"		"noclip"
		"xpos"		"20"
		"ypos"		"140"
		"wide"		"150"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Allow Noclip"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
		"Default"		"1"
		"checked"		"1"
	}
	"divider"
	{
		"ControlName"		"Divider"
		"fieldName"		"divider"
		"xpos"		"180"
		"ypos"		"20"
		"wide"		"2"
		"tall"		"400"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
]]

local limits = {
{ name="props", max=256 },
{ name="ragdolls", max=32 },
{ name="npcs", max=32 },
{ name="balloons", max=64 },
{ name="wheels", max=64 },
{ name="lamps", max=32 },
{ name="buttons", max=64 },
{ name="dynamite", max=32 },
{ name="effects", max=128 },
{ name="emitters", max=32 },
{ name="hoverballs", max=64 },
{ name="sents", max=128 },
{ name="spawners", max=32 },
{ name="thrusters", max=64 },
{ name="turrets", max=32 },
{ name="vehicles", max=32 },
}

for mul, info in ipairs( limits ) do
	local name = info.name
	local mulx = math.floor( (mul-1) / 8 ) -- Make rows of 8
	local muly = math.fmod( mul-1, 8 )
	adminRes = adminRes .. [[
	"]] .. name .. [[lbl"
	{
		"ControlName"		"Label"
		"fieldName"		"]] .. name .. [[lbl"
		"xpos"		"]] .. 200 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 20 .. [["
		"wide"		"128"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"Max ]] .. string.upper( name:sub( 1, 1 ) ) .. name:sub( 2 ) .. [[:"
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
	}
	"]] .. name .. [[slider"
	{
		"ControlName"		"Slider"
		"fieldName"		"]] .. name .. [[slider"
		"xpos"		"]] .. 200 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 40 .. [["
		"wide"		"200"
		"tall"		"20"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
	"]] .. name .. [[num"
	{
		"ControlName"		"Label"
		"fieldName"		"]] .. name .. [[num"
		"xpos"		"]] .. 410 + mulx*250 .. [["
		"ypos"		"]] .. muly*50 + 40 .. [["
		"wide"		"64"
		"tall"		"24"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		""
		"textAlignment"		"west"
		"dulltext"		"0"
		"brighttext"		"0"
		"wrap"		"0"
	}
]]
end

adminRes = adminRes .. "}"

local adminMenu

function ulx.showAdminMenu()
	-- We COULD use this line if we weren't taking such a hackish approach with the checkboxes.
	-- if adminMenu then adminMenu:SetVisible( true ) return end
	if adminMenu then adminMenu:SetVisible( false ) end

	adminMenu = vgui.Create( "Frame" )
	adminMenu:SetName( "window" )
	
	local npcs = vgui.Create( "CheckButton", adminMenu, "npcs" )
	local status = util.tobool( GetConVarNumber( "sbox_allownpcs" ) )
	if status then
		npcs:SetText( "Disallow NPCs" )
	else
		npcs:SetText( "Allow NPCs" )
	end
	npcs:SetActionFunction( function() LocalPlayer():ConCommand( string.format( "ulx rcon sbox_allownpcs %i\n", math.fmod( GetConVarNumber( "sbox_allownpcs" ) + 1, 2 ) ) ) end )

	local god = vgui.Create( "CheckButton", adminMenu, "god" )
	local status = util.tobool( GetConVarNumber( "sbox_godmode" ) )
	if status then
		god:SetText( "Disable Global Godmode" )
	else
		god:SetText( "Enable Global Godmode" )
	end
	god:SetActionFunction( function() LocalPlayer():ConCommand( string.format( "ulx rcon sbox_godmode %i\n", math.fmod( GetConVarNumber( "sbox_godmode" ) + 1, 2 ) ) ) end )

	local pvp = vgui.Create( "CheckButton", adminMenu, "pvp" )
	local status = util.tobool( GetConVarNumber( "sbox_plpdamage" ) )
	if status then
		pvp:SetText( "Enable PvP Damage" )
	else
		pvp:SetText( "Disable PvP Damage" )
	end
	pvp:SetActionFunction( function() LocalPlayer():ConCommand( string.format( "ulx rcon sbox_plpdamage %i\n", math.fmod( GetConVarNumber( "sbox_plpdamage" ) + 1, 2 ) ) ) end )

	local noclip = vgui.Create( "CheckButton", adminMenu, "noclip" )
	local status = util.tobool( GetConVarNumber( "sbox_noclip" ) )
	if status then
		noclip:SetText( "Disable Noclip" )
	else
		noclip:SetText( "Enable Noclip" )
	end
	noclip:SetActionFunction( function() LocalPlayer():ConCommand( string.format( "ulx rcon sbox_noclip %i\n", math.fmod( GetConVarNumber( "sbox_noclip" ) + 1, 2 ) ) ) end )
	
	for _, info in ipairs( limits ) do
		local name = info.name
		local max = info.max
		local cur = GetConVarNumber( "sbox_max" .. name )
		local num = vgui.Create( "Label", adminMenu, name .. "num" )
		num:SetText( cur )
		local slider = vgui.Create( "Slider", adminMenu, name .. "slider" )
		slider:PostMessage( "SetInteger", "b", "1" )
		slider:PostMessage( "SetLower", "f", "0" )
		slider:PostMessage( "SetHigher", "f", max )
		slider:PostMessage( "SetValue", "f", cur )
		slider:SetActionFunction( function( panel, action, value )
			if value ~= GetConVarNumber( "sbox_max" .. name ) then
				LocalPlayer():ConCommand( string.format( "ulx rcon sbox_max%s %i\n", name, value ) )
			       	num:SetText( value )
			end
		end )
	end

	adminMenu:LoadControlsFromString( adminRes )
	adminMenu:SetKeyBoardInputEnabled( true )
	adminMenu:SetMouseInputEnabled( true )

	adminMenu:SetPos( ScrW()*0.3, ScrH()-500 )
	adminMenu:SetVisible( true )
end












--------------
--Client Menu--
--------------
local clientRes = [["client"
{
	"window"
	{
		"ControlName"		"Frame"
		"fieldName"		"window"
		"xpos"		"489"
		"ypos"		"400"
		"zpos"		"290"
		"wide"		"600"
		"tall"		"400"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"settitlebarvisible"		"1"
		"title"		"ULX Client Menu"
		"sizable"		"0"
	}
	"divider"
	{
		"ControlName"		"Divider"
		"fieldName"		"divider"
		"xpos"		"20"
		"ypos"		"200"
		"wide"		"560"
		"tall"		"2"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
	}
]]

local actions = {
"slap",
"slay",
"sslay",
"ignite",
"kick",
"ban",
"jail",
"unjail",
"ragdoll",
"unragdoll",
"gimp",
"ungimp",
"mute",
"unmute",
"freeze",
"unfreeze",
"god",
"ungod",
"cloak",
"uncloak",
"spectate",
}

for mul, action in ipairs( actions ) do
	local mulx = math.floor( (mul-1) / 4 ) -- Make rows of 4
	local muly = math.fmod( mul-1, 4 )
	clientRes = clientRes .. [[
	"]] .. action .. [["
	{
		"ControlName"		"Button"
		"fieldName"		"]] .. action .. [["
		"xpos"		"]] .. 30 + mulx*90 .. [["
		"ypos"		"]] .. muly*40 + 220 .. [["
		"zpos"		"290"
		"wide"		"80"
		"tall"		"30"
		"autoResize"		"0"
		"pinCorner"		"0"
		"visible"		"1"
		"enabled"		"1"
		"tabPosition"		"0"
		"labelText"		"]] .. string.upper( action:sub( 1, 1 ) ) .. action:sub( 2 ) .. [["
		"textAlignment"		"center"
		"dulltext"		"0"
		"brighttext"		"0"
		"font"		"Default"
		"wrap"		"0"
		"Command"		"]] .. action .. [["
		"Default"		"0"
	}
]]
end

clientRes = clientRes .. "}"

local clientMenu
local selectedPly

local function routeCommand( panel, type, command )
	if not selectedPly then return end
	LocalPlayer():ConCommand( string.format( "ulx %s \"%s\"\n", command, selectedPly:Nick() ) )
end

function ulx.showClientMenu()
	-- We COULD use this line if we weren't taking such a hackish approach.
	-- if clientMenu then clientMenu:SetVisible( true ) return end
	if clientMenu then clientMenu:SetVisible( false ) selectedPly = nil end

	clientMenu = vgui.Create( "Frame" )
	clientMenu:SetName( "window" )
	
	local clientRes = string.sub( string.Trim( clientRes ), 1, -2 ) -- Make a local copy, going to change it. Cut off the "}".
	
	local players = player.GetAll()
	local num = 0
	for _, player in ipairs( players ) do
		num = num + 1
		local mulx = math.floor( (num-1) / 8 ) -- Make rows of 8
		local muly = math.fmod( num-1, 8 )
		clientRes = clientRes .. [[
		"ply]] .. num .. [["
		{
			"ControlName"		"RadioButton"
			"fieldName"		"ply]] .. num .. [["
			"xpos"		"]] .. 20 + mulx*150 .. [["
			"ypos"		"]] .. muly*20 + 30 .. [["
			"wide"		"130"
			"tall"		"24"
			"autoResize"		"0"
			"pinCorner"		"0"
			"visible"		"1"
			"enabled"		"1"
			"tabPosition"		"0"
			"labelText"		"]] .. player:Nick() .. [["
			"textAlignment"		"west"
			"dulltext"		"0"
			"brighttext"		"0"
			"wrap"		"0"
			"Default"		"0"
			"SubTabPosition"		"0"
		}
	]]
		local radiobox = vgui.Create( "RadioButton", clientMenu, "ply" .. num )
		radiobox:SetActionFunction( function() selectedPly = player end )
	end
	clientRes = clientRes .. "}"
	
	for _, action in ipairs( actions ) do
		local button = vgui.Create( "Button", clientMenu, action )
		button:SetActionFunction( routeCommand )
	end


	clientMenu:LoadControlsFromString( clientRes )
	clientMenu:SetKeyBoardInputEnabled( true )
	clientMenu:SetMouseInputEnabled( true )

	clientMenu:SetPos( ScrW()*0.3, ScrH()-500 )
	clientMenu:SetVisible( true )
end